/*
  autoAB_prj.c

*/
#include "simpletools.h"
#include "abdrive.h"
#include "sonyremote.h"
#include <sys/rtc.h>
#include "ping.h"
#include "fdserial.h"
#include "simpletext.h"

volatile unsigned int IRpin = 8;

static volatile int speedLeft = 0;
static volatile int speedRight = 0;
static volatile int roamcmd;
static volatile int speedLeftOld = 0;
static volatile int speedRightOld = 0;

serial *xbee;

// Function prototype
int IR_remote(int irPin);
void ab_nav(void);
void global_Roam(void);
int XB_remote(void);

///////////////////////////////////////////////////////////////////////////////
int main()
{
  // Add startup code here.
  int DO = 22, CLK = 23, DI = 24, CS = 25;      // SD card pins
  sd_mount(DO, CLK, DI, CS);                    // Mount SD card
  high(26);   // Razzle dazzle
  pause(500);

/*                     Rx  Tx mode BAUD */
  xbee = fdserial_open(7, 6, 0, 9600);
  high(27);  // Razzle dazzle
  pause(500);
  low(26),low(27);

  int roamcmdOld = roamcmd;
  int speedLold2 = speedLeft;
  int speedRold2 = speedRight;

  int key = -1, xbcmd = -1;

  // Temp time test
  char timebuff[16];
  time_t now = 0;
  now = time(&now);
  strftime(timebuff,16,"%T",localtime(&now));
  printf("%s\n",timebuff); // If I use print(...), causes error, hub overflow
  //
 
  while(1)
  {
    // Add main loop code here.
    key = IR_remote(IRpin);
    xbcmd = XB_remote();
    if(key == 1) global_Roam();
    ab_nav();
  }  
}
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
void ab_nav(void)
{
  if(speedLeftOld != speedLeft || speedRightOld != speedRight)
  {
    drive_speed(speedLeft, speedRight);
    speedLeftOld = speedLeft;
    speedRightOld = speedRight;
  } 
  pause(20);
}

///////////////////////////////////////////////////////////////////////////////
/* IR remote control */
int IR_remote(int irPin)
{
  toggle(26);  // Razzle dazzle
  int key;
  ir_tLimit(50);

  key = ir_key(irPin);
  if(key == PWR)
  {
    speedLeft = 0;
    speedRight = 0;
  }
  if(key == CH_UP)  // CH_UP -> Forward
  {
    speedLeft = 32;
    speedRight = 32;
  }
  if(key == CH_DN)  // CH_DN -> Backward
  {
    speedLeft = -32;
    speedRight = -32;
  }
  if(key == VOL_UP)  // VOL_UP -> Right
  {
    speedLeft = 16;
    speedRight = -16;
  }
  if(key == VOL_DN)  // VOL_DN -> Left
  {
    speedLeft = -16;
    speedRight = 16;
  }
//  if(key == MUTE)
//  {
//    fclose(fp);
//    high(26);
//    while(1);
//  }
//  if(key == ENTER)
//  {
//    fp = fopen("log.txt", "w");
//  }

//  if(key != -1)
//  {
    // set up string for value
//    char val[] = {' ', ' ', ' ', '\r', '\n'};
    // key to string over spaces in val
//    itoa(key, val, 10);    
    // display in terminal to verify
//    putLine(val);  
    // store string to log.txt
//    fwrite(val, 1, 6, fp); 
//  }

  return key; 
}

///////////////////////////////////////////////////////////////////////////////
void global_Roam(void)
{
  int turn;
//  roamcmd = 0;
  while(1)
  {
    if(IR_remote(IRpin) == PWR)
      return;
    else
    {
      speedLeft = 32;
      speedRight = 32;
      ab_nav();
      pause(100);
      while(ping_cm(8) >= 20)
      {
        pause(5);
        if(IR_remote(IRpin) == PWR) return;
      } 
      if(IR_remote(IRpin) == PWR) return;

      turn = rand() % 2;
      if(turn == 1)

      {
        speedLeft = 16;
        speedRight = -16;
      }
      else
      {
        speedLeft = -16;
        speedRight = 16;
      }
      ab_nav();
      while(ping_cm(8) < 20);
      {
        pause(5);
        if(IR_remote(IRpin) == PWR) return;
      } 
    }
  } 
}

int XB_remote(void)
{
  toggle(27);  // Razzle dazzle
}
